# FlightGNC.jl
Julia package of GNC algorithms for autonomous systems

Open repository on [binder](https://mybinder.org/v2/gh/nhcho91/FlightGNC.jl/master) / on [nbviewer](https://nbviewer.jupyter.org/github/nhcho91/FlightGNC.jl/tree/master/)
<!-- [![Build Status](https://github.com/nhcho91/FlightGNC.jl/workflows/CI/badge.svg)](https://github.com/nhcho91/GNC.jl/actions) -->
<!-- [![Coverage](https://codecov.io/gh/nhcho91/FlightGNC.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/nhcho91/GNC.jl) -->

## Related packages
- [FSimBase.jl](https://github.com/JinraeKim/FSimBase.jl): The lightweight base package for numerical simulation supporting nested dynamical systems and macro-based data logger.
- [FlightSims.jl](https://github.com/JinraeKim/FlightSims.jl): A general-purpose numerical simulator supporting nested environments and convenient macro-based data logging.
- [SimulationLogger.jl](https://github.com/JinraeKim/SimulationLogger.jl): A convenient logging tools compatible with [DifferentialEquations.jl](https://github.com/SciML/DifferentialEquations.jl).
- [FaultTolerantControl.jl](https://github.com/JinraeKim/FaultTolerantControl.jl):
fault tolerant control (FTC) with various models and algorithms of faults, fault detection and isolation (FDI), and reconfiguration (R) control.
